#!/bin/bash

ffoo import termcolors


FFOO_PRETTY_COLOR_DEBUG=""
FFOO_PRETTY_COLOR_DIE=""
FFOO_PRETTY_COLOR_USAGE_IS=""
FFOO_PRETTY_COLOR_THINK=""
FFOO_PRETTY_COLOR_WARN=""
FFOO_PRETTY_COLOR_OFF=""


__ffoo__pretty_color__init() {
    test -t 2 || return 0   # stderr is a pipe/file; refrain from colors
    FFOO_PRETTY_COLOR_DEBUG="${FFOO_TERMCOLORS_LBLUE}"
    FFOO_PRETTY_COLOR_DIE="${FFOO_TERMCOLORS_LRED}"
    FFOO_PRETTY_COLOR_USAGE_IS="${FFOO_TERMCOLORS_YELLOW}"
    FFOO_PRETTY_COLOR_THINK="${FFOO_TERMCOLORS_LBLACK}"
    FFOO_PRETTY_COLOR_WARN="${FFOO_TERMCOLORS_LRED}"
    FFOO_PRETTY_COLOR_OFF="${FFOO_TERMCOLORS_NONE}"
}


_pretty_debug() {
    while IFS= read line;
    do echo -ne "${FFOO_PRETTY_COLOR_DEBUG}debug:$caller:$FFOO_PRETTY_COLOR_OFF"
       echo "$line"; done
}


_pretty_die() {
    echo -ne "$FFOO_PRETTY_COLOR_DIE"
    while IFS= read line;
    do echo "$line"; done
    echo -ne "$FFOO_PRETTY_COLOR_OFF"
}


_pretty_usage_is() {
    echo -ne "$FFOO_PRETTY_COLOR_USAGE_IS"
    while IFS= read line;
    do echo -e "$line"; done
    echo -ne "$FFOO_PRETTY_COLOR_OFF"
}


_pretty_think() {
    echo -ne "$FFOO_PRETTY_COLOR_THINK"
    while IFS= read line;
    do echo "$line"; done
    echo -ne "$FFOO_PRETTY_COLOR_OFF"
}


_pretty_warn() {
    echo -ne "$FFOO_PRETTY_COLOR_WARN"
    while IFS= read line;
    do echo "$line"; done
    echo -ne "$FFOO_PRETTY_COLOR_OFF"
}
